-- Forlorn Fox
-- Copyright © 2014 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--
RawMapData {
    "################################",
    "#                              #",
    "#   2UP   #############   1UP  #",
    "#   * *   #           #    +   #",
    "# ####### # Maze  Tag #  ##### #",
    "# #     # #   Lobby   #  #   # #",
    "# # $ $ # #    ---    #  # ~ # #",
    "# #     # #    - -    #  #   # #",
    "# ##   ## #####---#####  ## ## #",
    "#             #####            #",
    "#                              5",
    "#                              #",
    "#    3UP               4UP     #",
    "#   ? ? ?            @ @ @ @   #",
    "# #########        ########### #",
    "# #       #        #         # #",
    "# # % % % #        # ^ ^ ^ ^ # #",
    "# #       #        #         # #",
    "# ###   ###        ####   #### #",
    "#                              #",
    "################################",
    title = "Let's Play Maze Tag",
    
    exits = {   
        ['5'] = { file = "central_cavern",  destination = '5'}, 
    },
    
    preload = { 
        {file='maze_tag_2_player'}, -- force preload in clients
        {file='maze_tag_3_player'},
        {file='maze_tag_4_player'},
    },        
            
    features = { 
        { '#', from_utf8('#'), "AutoWall" },
        { ' ', ' ',            "Space" },
        { '5', '5',            "Space" },
    },
    
    controllers = { },
    
    objects = 
    {
      on_map = 
      {
        ['-'] = {name="start light", group=5, status='off', 
		  glyphs={['off']=graphic_shorthand("Map.png", 9), ['on']=graphic_shorthand("Map.png", 10)}},
        ['+'] = {name="start light", group=1, status='off', 
		  glyphs={['off']=graphic_shorthand("Map.png", 9), ['on']=graphic_shorthand("Map.png", 10)}},
        ['*'] = {name="start light", group=2, status='off', 
		  glyphs={['off']=graphic_shorthand("Map.png", 9), ['on']=graphic_shorthand("Map.png", 10)}},
        ['?'] = {name="start light", group=3, status='off', 
		  glyphs={['off']=graphic_shorthand("Map.png", 9), ['on']=graphic_shorthand("Map.png", 10)}},
        ['@'] = {name="start light", group=4, status='off', 
		  glyphs={['off']=graphic_shorthand("Map.png", 9), ['on']=graphic_shorthand("Map.png", 10)}},
        ['~'] = {name="exit_pad", group=1, file="maze_tag_2_player", destination='start', map_character = graphic_shorthand("Map.png", 11)},
        ['$'] = {name="exit_pad", group=2, file="maze_tag_2_player", destination='start', map_character = graphic_shorthand("Map.png", 11)},
        ['%'] = {name="exit_pad", group=3, file="maze_tag_3_player", destination='start', map_character = graphic_shorthand("Map.png", 11)},
        ['^'] = {name="exit_pad", group=4, file="maze_tag_4_player", destination='start', map_character = graphic_shorthand("Map.png", 11)},
      },
    },
    
    fg = 'GREEN',
    bg = 'BRIGHT_CYAN',
    
    manager_file = 'lobby_manager',
    manager_name = 'lobby_manager_maze_tag',
    
    game_name = "Maze Tag",
    --game_map = 'maze_tag_2_player',
    
    -- no treasure for reloaded map
    buried_gold_coin_density = 0,
    unburied_gold_coin_density = 0,
}
