-- Forlorn Fox
-- Copyright © 2015 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--
RawMapData {
    --[[
    map data procedurally generated
    --]]
    title = "Slime Escape",
    
    procedural = 
    {
        width = 100,
        height = 30,
        map_type = 'connected',  
        paths = 
        {
            { letter = 'w', path_type = 'maze',         min={l=10,c=49}, max={l=30,c=100} },
            { letter = 'x', path_type = 'maze',         min={l=1,c=1},   max={l=20,c=50}  },
            { letter = 'y', path_type = 'maze',         min={l=10,c=1},  max={l=30,c=50}  },
            { letter = 'z', path_type = 'last_maze',    min={l=1,c=49},  max={l=20,c=100} },
        }
    },
    
    chunks = 
    {
        -- 'b' in the chunks is a blank space that is available for procedural generation
        -- code to operate on
        
        -- start
        {
            line = 6,
            column = 1,
            "bbbbb########bbbb",
            "bbbb##      ####b",
            "bbbb#  ####    ##",
            "b####P########  x",
            "##### ######b####",
            "##        ##bbbbb",
            "##        ##bbbbb",
            "##  1     ##bbbbb",
            "##        ##bbbbb",
            "sS  2     ##bbbbb",
            "##        ##bbbbb",
            "##  3     ##bbbbb",
            "##        ##bbbbb",
            "##        ##bbbbb",
            "##### ######b####",
            "b####P########  y",
            "bbbb#  ####    ##",
            "bbbb##      ####b",
            "bbbbb########bbbb",
        },
        
        -- door room
        {
            line = 5,
            column = 48,
            "#######",
            "#  #  #",
            "#l #  z",
            "#  d  #",
            "x  #  #",
            "#  #  #",
            "#######",
        },
        
        -- door room
        {
            line = 18,
            column = 48,
            "#######",
            "#  #  #",
            "y  #  #",
            "#  e  #",
            "#k #  w",
            "#  #  #",
            "#######",
        },
    
        -- end
        {
            line = 6,
            column = 100-23+1,
            "#########bbbbbbbbbbbbbb",
            "##     ###bbbbbbbbbbbbb",
            "z  ###  ###bbbbbbbbbbbb",
            "#######  #########bbbbb",
            "bbbb####  #########bbbb",
            "bbbbb##        p#######",
            "bbbbb##         #######",
            "bbbbb##         #######",
            "bbbbb##         #   ###",
            "bbbbb##           # ##4",
            "bbbbb##         ### #  ",
            "bbbbb##         ###   #",
            "bbbbb##         #######",
            "bbbb###        p#######",
            "######### #############",
            "w ###     ########bbbbb",
            "#     ######bbbbbbbbbbb",
            "############bbbbbbbbbbb",
        },
        
    },


    manager_file = 'slime_escape_manager',
    manager_name = 'slime_escape_manager',  -- will need to be instanced if we want more than 1 game ongoing at a time
                                            -- unless we make the manager stateless and keep all state in the map structure

    exits = 
    {   
        ['1'] = {map_character = graphic_shorthand("Map.png", 13)}, 
        ['2'] = {map_character = graphic_shorthand("Map.png", 13)}, 
        ['3'] = {map_character = graphic_shorthand("Map.png", 13)}, 
        ['4'] = 
        {
            -- teleport to middle of 'turnwise'
            file = "turnwise",
            destination = '2',
            map_character = get_glyph('map',0x14),
            conditional = 'exit_active',
            condition = 2,
        },
    },
    
    conditionals =
    {
        exit_active = 0,
        red_door = 'closed',
        blue_door = 'closed',
        slime_door = 'closed',
    },
    
    features = 
    { 
        { '#', from_utf8('#'),              "AutoWall" },
        { ' ', ' ',                         "Space" },
        { 'c', 'c',                         "Space" }, -- 
        { 's', get_glyph('blackwall',0x75), "Space" }, -- slime
        { 'p', get_glyph('spectrum',0x11),  "Space" }, -- pad
        { 'd', 'd',                         "Space" }, -- door
        { 'e', 'e',                         "Space" }, -- door
        { 'S', 'S',                         "Space" }, -- door
        { 'P', get_glyph('spectrum',0x00),  "Space" }, -- invisible pad
        { 'k', get_glyph('dragon',0xC0),    "Space" }, -- key
        { 'l', get_glyph('dragon',0xC2),    "Space" }, -- key
        
        --[[
        { 'w', 'w',                         "Space" }, -- 
        { 'x', 'x',                         "Space" }, -- 
        { 'y', 'y',                         "Space" }, -- debug
        { 'z', 'z',                         "Space" }, -- 
        { 'W', 'W',                         "Space" }, -- 
        { 'X', 'X',                         "Space" }, -- 
        { 'Y', 'Y',                         "Space" }, -- debug
        { 'Z', 'Z',                         "Space" }, -- 
        --]]
    },
    
    doors = 
    {
        ['d'] =
        {
            conditional = 'red_door',
            closed = get_glyph('blackwall',0x05),
            open = get_glyph('blackwall',0x06),
        },
        ['e'] =
        {
            conditional = 'blue_door',
            closed = get_glyph('blackwall',0x1a),
            open = get_glyph('blackwall',0x1b),
        },
        ['S'] =
        {
            conditional = 'slime_door',
            closed = get_glyph('blackwall',0x1d),
            open = get_glyph('blackwall',0x1e), 
        },
    },
    
    active_floor = 
    {
        [get_glyph('blackwall',0x75)] = { "die" },
        [get_glyph('spectrum',0x11)]  = { "add", 'exit_active', 1,     get_glyph('spectrum',0x12) },    -- set conditional
        [get_glyph('dragon',0xC0)]    = { "set", 'red_door',   'open', get_glyph('dragon',0xC1)   },    -- set conditional
        [get_glyph('dragon',0xC2)]    = { "set", 'blue_door',  'open', get_glyph('dragon',0xC3)   },    -- set conditional
        [get_glyph('spectrum',0x00)]  = { "set", 'slime_door', 'open' },                                -- set conditional
    },
        
        
    controllers = { },
    objects = 
    { 
        on_map = {  ['c'] = 'gold coin',
                    ['s'] = 'slime' }
    },
    
    -- foreground and background colours the same for the blackwall glyph set...
    fg = 'X11_PURPLE',
    bg = 'X11_PURPLE',
    autowall_glyph_set = "blackwall"    
}
