
-- Forlorn Fox
-- Copyright © 2015 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--
--[[

    Glyph set definitions and helper functions
    
--]]

glyph_sets = {
    spectrum = { 
            name = "Spectrum", 
            filename = "Spectrum.png", 
            load_from_file = true, 
            glyph_size = 32,
            glyph_set_lines = 16, 
            characters_per_line = 16,
            multicolour = true,
            button_line = 2,                -- for the glyph editor load screen
            character_base_code = 0 },
    editor = { 
            name = "Editor 1", 
            filename = "Editor.png", 
            load_from_file = true, 
            glyph_size = 32,
            glyph_set_lines = 16, 
            characters_per_line = 16,
            multicolour = true,
            button_line = 3,                -- for the glyph editor load screen
            character_base_code = 0xE000 },
    dragon = { 
            name = "Dragon", 
            filename = "Dragon.png", 
            load_from_file = true, 
            glyph_size = 32,
            glyph_set_lines = 16, 
            characters_per_line = 16,
            multicolour = true,
            button_line = 9,                -- for the glyph editor load screen
            character_base_code = 0xE100 },
    glyph_editor_temp16 = { 
            name = "", 
            filename = "", 
            load_from_file = false, 
            glyph_size = 16,
            glyph_set_lines = 1, 
            characters_per_line = 2,
            multicolour = true,
            character_base_code = 0xE200 },
    editor2  = { 
            name = "Editor 2", 
            filename = "Editor2.png", 
            load_from_file = true, 
            glyph_size = 32,
            glyph_set_lines = 16, 
            characters_per_line = 16,
            multicolour = true,
            button_line = 4,                -- for the glyph editor load screen
            character_base_code = 0xE300 },
    map = { 
            name = "Map", 
            filename = "Map.png", 
            load_from_file = true, 
            glyph_size = 32,
            glyph_set_lines = 16, 
            characters_per_line = 16,
            multicolour = true,
            button_line = 6,                -- for the glyph editor load screen
            character_base_code = 0xE400 },
    townmap = { 
            name = "Town Map", 
            filename = "TownMap.png", 
            load_from_file = true, 
            glyph_size = 32,
            glyph_set_lines = 16, 
            characters_per_line = 16,
            multicolour = true,
            button_line = 7,                -- for the glyph editor load screen
            character_base_code = 0xE500 },
    mobs = { 
            name = "Mobs", 
            filename = "Mobs.png", 
            load_from_file = true, 
            glyph_size = 32,
            glyph_set_lines = 16, 
            characters_per_line = 16,
            multicolour = true,
            button_line = 8,                -- for the glyph editor load screen
            character_base_code = 0xE600 },
    glyph_editor_temp32 = { 
            name = "", 
            filename = "", 
            load_from_file = false, 
            glyph_size = 32,
            glyph_set_lines = 1, 
            characters_per_line = 2,
            multicolour = true,
            character_base_code = 0xE700 },
    blackwall = { 
            name = "Blackwall", 
            filename = "Blackwall.png", 
            load_from_file = true, 
            glyph_size = 32,
            glyph_set_lines = 16, 
            characters_per_line = 16,
            multicolour = true,
            button_line = 10,                -- for the glyph editor load screen
            character_base_code = 0xE800 },        
    caves1 = { 
            name = "caves1", 
            filename = "caves1.png", 
            load_from_file = true, 
            glyph_size = 32,
            glyph_set_lines = 16, 
            characters_per_line = 16,
            multicolour = true,
            button_line = 11,                -- for the glyph editor load screen
            character_base_code = 0xE900 },      
    caves2 = { 
            name = "caves2", 
            filename = "caves2.png", 
            load_from_file = true, 
            glyph_size = 32,
            glyph_set_lines = 16, 
            characters_per_line = 16,
            multicolour = true,
            button_line = 12,                -- for the glyph editor load screen
            character_base_code = 0xEA00 },  
    editor3 = { 
            name = "editor3", 
            filename = "editor3.png", 
            load_from_file = true, 
            glyph_size = 32,
            glyph_set_lines = 16, 
            characters_per_line = 16,
            multicolour = true,
            button_line = 5,                -- for the glyph editor load screen
            character_base_code = 0xEB00 },  
    treemap = { 
            name = "Tree Map", 
            filename = "Treemap.png", 
            load_from_file = true, 
            glyph_size = 32,
            glyph_set_lines = 16, 
            characters_per_line = 16,
            multicolour = true,
            button_line = 13,                -- for the glyph editor load screen
            character_base_code = 0xEC00 },
    tree = { 
            name = "Tree", 
            filename = "Tree.png", 
            load_from_file = true, 
            glyph_size = 32,
            glyph_set_lines = 16, 
            characters_per_line = 16,
            multicolour = true,
            button_line = 14,                -- for the glyph editor load screen
            character_base_code = 0xED00 },
        
}

-- adding a new glyph set:
-- glyph sets are 0x0100 apart - this is hardcoded
-- 256 in a block (square 16x16) and 0x0100 apart.


function get_glyph(glyph_set, offset)
    return glyph_sets[glyph_set].character_base_code + offset
end

function get_glyph_set_base_code(glyph_set)
    return glyph_sets[glyph_set].character_base_code
end


function graphic_shorthand(filename, offset)

    -- at the moment, loop
    for _, v in pairs(glyph_sets) do
        if v.filename == filename then
            return v.character_base_code + offset
        end
    end
    
    -- if we can't find, assume first set...
    return 0 + offset
end
