-- Forlorn Fox
-- Copyright © 2014 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--

 
 require("strict")
local class = require("middleclass")
local credits = class("credits")


function credits:initialize()
    self._worker = gulp_cpp.TitleScreen(gulp.app:get_SDL_renderer(), gulp.forlorn_fox_version)
    gulp._delegate_list:add_delegate(self)
    gulp.add_user_movement_target(self)
    gulp.app:set_background_colour(gulp.colour.BLUE.simple_colour)
    self._clicked = false
end

function credits:draw(gr)
    gr:set_game_screen_offset(false) 
    self._worker:print(gr)
end

function credits:update(dt)
    self._worker:update(dt)
end

function credits:mousepressed(x, y, handled)
    self._clicked = true
    return true
end

function credits:mousereleased(x, y, handled)
    -- only close if we've seen a click before
    if self._clicked == true then
        self:close()
    end
    return true
end

function credits:keypressed(sym, scancode, modifier, repeated)
    if not gulp.function_key_monitor:keypressed(sym, scancode, modifier, repeated) then
        self:close()
    end
    
    return true
end


function credits:close()
    gulp.remove_user_movement_target(self)
    gulp._delegate_list:drop_delegate(self)
    
    -- allow it to be garbage collected
    self._worker = nil
    
    -- restore normal clear
    gulp.app:set_background_colour(gulp.colour.BLACK.simple_colour)    
    -- whatever the credits have done, restore game screen offset
    gulp.app:get_standard_graphics_context():set_game_screen_offset(true)
    
    gulp.main_menu = main_menu()
end


return credits